std::out_of_range(3)

NAME
std::out_of_range - std::out_of_range

Synopsis
   Defined in header <stdexcept>
   class out_of_range;
   Defines a type of object to be thrown as exception. It reports errors that are
   consequence of attempt to access elements out of defined range.
   It may be thrown by the member functions of std::bitset and std::basic_string, by
   std::stoi and std::stod families of functions, and by the bounds-checked member
   access functions (e.g. std::vector::at and std::map::at).
   std-out of range-inheritance.svg
                        Inheritance diagram

Member functions
   constructor constructs a new out_of_range object with the given message
                 (public member function)
   operator= replaces the out_of_range object
                 (public member function)
   what returns the explanatory string
                 (public member function) std::out_of_range::out_of_range
   out_of_range( const std::string& what_arg ); (1)
   out_of_range( const char* what_arg ); (2) (since C++11)
   out_of_range( const out_of_range& other ); (3) (until C++11)
   out_of_range( const out_of_range& other ) noexcept; (since C++11)
   1-2) Constructs the exception object with what_arg as explanatory string that can be
   accessed through what().
   3) Copy constructor.
   If *this and other both have dynamic type std::out_of_range then std::strcmp(what(),
   other.what()) == 0.
   (since C++11)

Parameters
   what_arg - explanatory string
   other - another exception object to copy

Exceptions
   1-2) May throw std::bad_alloc

Notes
   Because copying std::out_of_range is not permitted to throw exceptions, this message
   is typically stored internally as a separately-allocated reference-counted string.
   This is also why there is no constructor taking std::string&&: it would have to copy
   the content anyway. std::out_of_range::operator=
   out_of_range& operator=( const out_of_range& other ); (until C++11)
   out_of_range& operator=( const out_of_range& other ) noexcept; (since C++11)
   Assigns the contents with those of other.
   If *this and other both have dynamic type std::out_of_range then std::strcmp(what(),
   other.what()) == 0 after assignment.
   (since C++11)

Parameters
   other - another exception object to assign with

Return value
   *this std::out_of_range::what
   virtual const char* what() const throw(); (until C++11)
   virtual const char* what() const noexcept; (since C++11)
   Returns the explanatory string.

Parameters
   (none)

Return value
   Pointer to a null-terminated string with explanatory information. The string is
   suitable for conversion and display as a std::wstring. The pointer is guaranteed to
   be valid at least until the exception object from which it is obtained is destroyed,
   or until a non-const member function (e.g. copy assignment operator) on the
   exception object is called.

Notes
   Implementations are allowed but not required to override what(). Inherited from std::logic_error Inherited from std::exception

Member functions
   destructor destroys the exception object
   [virtual] (virtual public member function of std::exception)
   what returns an explanatory string
   [virtual] (virtual public member function of std::exception)

Notes
   The standard error condition std::errc::result_out_of_range typically indicates the
   condition where the result, rather than the input, is out of range, and is more
   closely related to std::range_error and ERANGE.

See also
   at accesses the specified character with bounds checking
           (public member function of std::basic_string<CharT,Traits,Allocator>)
   at accesses the specified character with bounds checking
   (C++17) (public member function of std::basic_string_view<CharT,Traits>)
   at access specified element with bounds checking
           (public member function of std::deque<T,Allocator>)
   at access specified element with bounds checking
           (public member function of std::vector<T,Allocator>)
   at access specified element with bounds checking
   (C++11) (public member function of std::array<T,N>)